package com.enoram.restifycore;

import com.google.gson.Gson;
public class AbstractSerializationStreamReader extends AbstractSerializationStream  implements SerializationReader {

	private String response;
	private String typeSignature;
	private Class<?> genericReturnType;
	@Override
	public Object deserialize(String typeSignature, String response)
			throws SerializationException {
		
		return deserialize(typeSignature,Void.class, response);
	}
	
	private void _deserialize(String typeSignature, Class<?> genericReturnType,
			String response){
		
		response = response.replaceAll("\r", "");
		response = response.replaceAll("\n", "");
		this.response = response;
		
		this.typeSignature = typeSignature;
		this.genericReturnType = Void.class;
	}
	@Override
	public Object deserialize(String typeSignature, Class<?> genericReturnType,
			String response) throws SerializationException {
		
		_deserialize(typeSignature, genericReturnType, response);
		
		if(typeSignature.equals("int") || typeSignature.equals("java.lang.Integer")){
			return readInt();
		}else if(typeSignature.equals("long") || typeSignature.equals("java.lang.Long")){
			return readLong();
		}else if(typeSignature.equals("java.lang.String")){
			return readString();			
		}else if(typeSignature.equals("boolean") || typeSignature.equals("java.lang.Boolean")){
			return readBoolean();
		}else {
			return readObject();
		}
	}
	@Override
	public boolean readBoolean() throws SerializationException {		
		return Boolean.parseBoolean(response);
	}

	@Override
	public byte readByte() throws SerializationException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public char readChar() throws SerializationException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public double readDouble() throws SerializationException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public float readFloat() throws SerializationException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public int readInt() throws SerializationException {
		
		return Integer.parseInt(response);
	}

	@Override
	public long readLong() throws SerializationException {
		return Long.parseLong(response);
	}

	@Override
	public Object readObject() throws SerializationException {
	
		Class<?> clazz;
		try {
			
			clazz = Class.forName(typeSignature);
			Gson gson = new Gson();
			Object object = gson.fromJson(response,	clazz);
			return object;
		} catch (ClassNotFoundException e) {	
			e.printStackTrace();
			throw new SerializationException(e);
		}
	}


	
	@Override
	public short readShort() throws SerializationException {
		return Short.parseShort(response);
	}

	@Override
	public String readString() throws SerializationException {
		return response;
	}
	
	@Override
	public void close() {
		response = "";
		
		
	}



}
