package com.enoram.restifycore;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpRequestBase;
import org.apache.http.entity.InputStreamEntity;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
 

public class HttpExecuteImpl implements HttpExecute{
 
	private static int COUNTER=0;
    /**
     * A generic method to execute any type of Http Request and constructs a response object
     * @param requestBase the request that needs to be exeuted
     * @return server response as <code>String</code>
     */
    private  String executeRequest(HttpRequestBase requestBase){
    	System.out.println("Counter::: "+ ++COUNTER);
        String responseString = "" ;
 
        InputStream responseStream = null ;
        HttpClient client = new DefaultHttpClient () ;
        try{
            HttpResponse response = client.execute(requestBase) ;
            if (response != null){
                HttpEntity responseEntity = response.getEntity() ;
 
                if (responseEntity != null){
                    responseStream = responseEntity.getContent() ;
                    if (responseStream != null){
                        BufferedReader br = new BufferedReader (new InputStreamReader (responseStream)) ;
                        String responseLine = br.readLine() ;
                        String tempResponseString = "" ;
                        while (responseLine != null){
                            tempResponseString = tempResponseString + responseLine + System.getProperty("line.separator") ;
                            responseLine = br.readLine() ;
                        }
                        br.close() ;
                        if (tempResponseString.length() > 0){
                            responseString = tempResponseString ;
                        }
                    }
                }
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }finally{
            if (responseStream != null){
                try {
                    responseStream.close() ;
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        client.getConnectionManager().shutdown() ;
 
        return responseString ;
    }
    private void setupRestHeader(HttpRequestBase requestBase){
    	//Content-Type: text/x-restify-rest;charset=UTF-8
    	requestBase.setHeader("Content-Type","text/x-restify-rest;charset=UTF-8");
    }
    private String executeInputStreamEntityRequest(String urlString, File file) {
        HttpPost postRequest = new HttpPost (urlString) ;
        try{
 
        	FileInputStream fin = new FileInputStream(file);
        	
           InputStreamEntity inEn = new InputStreamEntity(fin, file.length());
 
       
            
            postRequest.setEntity(inEn) ;
        }catch (Exception ex){
            ex.printStackTrace() ;
        }
        return executeRequest (postRequest) ;
    }
    
    public String executePostRequest(String urlString){
    	HttpPost postRequest = new HttpPost (urlString) ;
    	setupRestHeader(postRequest);
    	 return executeRequest (postRequest) ;
    }
    
    public String executeGetRequest(String urlString){
    	HttpGet getRequest = new HttpGet (urlString) ;
    	setupRestHeader(getRequest);
    	 return executeRequest (getRequest) ;
    }
    
   



    
    private  String deleteFile(String blobKey){
    	String urlString = "http://erjo-beta.cenifaxapps.com/" + "uploadbs?blobKey="+blobKey;
    	HttpDelete delRequest = new HttpDelete(urlString) ;
    	
    	return executeRequest(delRequest);
    }
    
    private  String createUploadUrlBS(String bucketName){
    	
    	String urlString = "http://erjo-beta.cenifaxapps.com/" + "uploadbs?bucketName="+bucketName;
    	HttpGet getRequest = new HttpGet(urlString) ;
    	
    	return executeRequest(getRequest);
    }

    


    public String encoded(String param) {
		try {
			return URLEncoder.encode(param,"UTF-8");
		} catch (UnsupportedEncodingException e) {
			
			e.printStackTrace();
		}
		return null;
	}

	@Override
	public String executePostWithBodyRequest(String json, String urlString) {

		HttpPost post = new HttpPost(urlString);

		try {

			if (json != null && !json.isEmpty()) {
				StringEntity myEntity = new StringEntity(json);
				myEntity.setContentEncoding("UTF-8");
				myEntity.setContentType("text/plain");
				post.setEntity(myEntity);
			}

			return executeRequest (post) ;
		} catch (Exception e) {
			e.printStackTrace();
			return "FAIL " + e.getLocalizedMessage();
		} 

	}
	@Override
	public String uploadFilePart(String baseUrl, String fileName) {
		// TODO Auto-generated method stub
		return null;
	}
}
