package com.enoram.restifycore;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.logging.Logger;

import com.google.gson.Gson;
public class HttpRequestSerializationWriter extends
		AbstractSerializationStreamWriter {
	private static Logger logger = Logger
			.getLogger(HttpRequestSerializationWriter.class.getName());
	private StringBuilder sb = new StringBuilder();
	private StringBuilder jsonSb = new StringBuilder();

	@Override
	protected void append(String token) {

		append(sb, token);

	}

	@Override
	public String toString() {
		return sb.toString();
	}

	private void append(StringBuilder sb, String token) {
		boolean nameVar = token.endsWith("=");
		
		if(nameVar){
			if (sb.length() > 0) {
				sb.append(QUERY_STR_SEPARATOR_CHAR);
			}
			sb.append(token);
		}else{
			appendEncoded(sb, token);
		}
	}
	
	private void appendEncoded(StringBuilder sb,String value){
		sb.append(encoded(value));
	}

	public static String encoded(String param) {
		try {
			return URLEncoder.encode(param, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			logger.severe("Error encoded " + param);
			e.printStackTrace();
		}

		return null;
	}

	@Override
	public void close() {
		sb = new StringBuilder();
		jsonSb = new StringBuilder();

	}

//	public void serialize(Object instance, String typeSignature)
//			throws SerializationException {
//
//		if (typeSignature.equals("int") 	|| typeSignature.equals("java.lang.Integer")) {
//			writeString("" + instance);
//		} else if (typeSignature.equals("long") || typeSignature.equals("java.lang.Long")) {
//			writeString("" + instance);
//		} else if (typeSignature.equals("int") || typeSignature.equals("java.lang.String")) {
//			writeString("" + instance);
//		} else if (typeSignature.equals("boolean") || typeSignature.equals("java.lang.Boolean")) {
//			writeString("" + instance);
//		} else {
//			writeObject(instance);
//		}
//
//	}

	/**
	 * Using Json to write object to String notation
	 */
	@Override
	public void writeObject(Object value) throws SerializationException {
		Gson gson = new Gson();
		String json = gson.toJson(value);

		writeString(json);

	}
	
	@Override
	public void writeObjectAsBodyContent(Object value){
		Gson gson = new Gson();
		String json = gson.toJson(value);
	
		jsonSb.append(json);
	}

	@Override
	public String getBody() {
		return jsonSb.toString();
	}

	public static void main(String[] args) throws SerializationException {
		SerializationWriter writer = new HttpRequestSerializationWriter();

		writer.writeString("name=test123");
		writer.writeString("name2=test123 with spaces");

		System.out.println("" + writer); writer.close();
		
		writer.writeString("name="); writer.serialize("value 4>3",String.class.getName());
		writer.writeString("name2="); writer.serialize("test123 with spaces", String.class.getName());

		writer.writeString("comment=");
		
		System.out.println("" + writer); writer.close();

	}
}
