package com.enoram.restifycore;


public interface SerializationReader {
	Object deserialize(String typeSignature, String response) throws SerializationException;

	Object deserialize(String typeSignature, Class<?> genericReturnType, String response) throws SerializationException;

	
	boolean readBoolean() throws SerializationException;

	byte readByte() throws SerializationException;

	char readChar() throws SerializationException;

	double readDouble() throws SerializationException;

	float readFloat() throws SerializationException;

	int readInt() throws SerializationException;

	long readLong() throws SerializationException;

	Object readObject() throws SerializationException;

	short readShort() throws SerializationException;

	String readString() throws SerializationException;
	
	void close();
}
