package com.enoram.restifycore;


public interface SerializationWriter {
	
	void serialize(Object instance, String typeSignature)  throws SerializationException;
	/**
	   * Serializes the contents of this stream into a string.
	   * 
	   * @return a string that is the serialization of the contents of this stream
	   */
	  String toString();
	  
	  /**
	   * Serializes the object from a call direct to writeObject or serialize(instance, type) call.
	   * @return
	   */
	  String getBody();

	  void writeBoolean(boolean value) throws SerializationException;

	  void writeByte(byte value) throws SerializationException;

	  void writeChar(char value) throws SerializationException;

	  void writeDouble(double value) throws SerializationException;

	  void writeFloat(float value) throws SerializationException;

	  void writeInt(int value) throws SerializationException;

	  void writeLong(long value) throws SerializationException;

	  void writeObject(Object value) throws SerializationException;

	  void writeObjectAsBodyContent(Object value) throws SerializationException;
	  
	  void writeShort(short value) throws SerializationException;

	  void writeString(String value) throws SerializationException;
	  void close();
}
